/* Weapon restriction for CS 1.6 BETA*/
/* Sir Drink a lot, 10.09.03 */

/*Commands for item restriction:

admin_showitems <no.>: Displays the ITEM-IDs for all items
admin_weaponscheck <"on" | "off">: Toggles whether or not weapon restrictions are used.

admin_enableallweapons: Allows anyone to buy any weapon.
admin_enableequipment: Allows anyone to buy any equipment.
admin_enableitem <item-id>: Allows anyone to buy the specified item.
admin_enablemenu <menu>: Allows anyone to buy anything on the specified menu.
admin_restrictallweapons: Forbids anyone from buying any weapon.
admin_restrictequipment: Forbids anyone from buying any equipment.
admin_restrictitem <item-id>: Forbids anyone from buying the specified item.
admin_restrictmenu <menu>: Forbids anyone from buying anything on the specified menu.

Changings:
0.6:	- fixed new exploit
	- weapon shortnames can be used for restriction
0.5:	- admin_cs_restrict value is displayed
0.3-0.4:- some code fixes.
0.2:	- settings of permission and restriction are stored in vault.ini
0.1: 	- Added some new admin_commands
	- Bugfix: restricting invalid menus
	- Bugfix: g_restricted counts the restrictions correctly.
0.08: 	- invalid menuselect commands are not detected as main menuselect.
	- Bugfix: this plugin should not get in conflict with other CS-menus.
0.06:	- invalid menuselect commands are not detected as item menuselect.
0.01:	- initial release
*/



#include <core>
#include <string>
#include <admin>
#include <adminlib>

new g_Version[] = "0.6";
#define ACCESS_VOTE_RESTART 1
#define ACCESS_RESTART 2
#define ACCESS_CHANGE_TEAM 8192
#define ACCESS_RESTRICT	8192
/*Currently available items*/
#define MAX_ITEMS	32
/*weapon restricted/enabled or buy/menuselected command detected*/
#define ENABLED		0
#define LOCKED		1
#define MENU_LOCKED	2
/*buy menus of weapon category in array g_Items*/
#define PISTOLS		5 	/*0-5: 			Menu 1*/
#define SHOTGUNS	7	/*PISTOLS+1 - 7: 	Menu 2*/
#define SMG		12	/*SHOTGUNS+1 - 12: 	Menu 3*/
#define RIFLES		22	/*SMG+1 - 22: 		Menu 4*/ 
#define MG 		23	/*RIFLES+1 - 23: 	Menu 5*/
#define EQUIPMENT	31	/*MG+1 - 31:		MENU 8*/
/*single buy menues*/
#define MENU_INVALID	0
#define MENU_PISTOLS	1
#define MENU_SHOTGUNS	2
#define MENU_SMGS	3
#define MENU_RIFLES	4
#define MENU_MG		5
#define MENU_SECAMMO	6
#define MENU_PRIMAMMO	7
#define MENU_EQUIPMENT	8
#define MENU_INVALID2	9
#define MENU_CANCEL	10
/*TEAMS*/
#define TERRORIST	1
#define COUNTER		2

/*For displaying to the user*/
new g_ItemsFakeName[MAX_ITEMS][MAX_NAME_LENGTH]={{"9x19MM SIDEARM"},{"KM .45 TACTICAL"},{"228 COMPACT"},{"NIGHT HAWK .50C"},
						{".40 DUAL ELITES"},{"ES FIVE-SEVEN"},{"LEONE 12 GAUGE"},{"LEONE YG 1265"},
						{"INGRAM MAC-10"},{"KM SMG"},{"KM UMP45"},{"ES C90"},{"SCHMIDT MACHINEGUN"},
						{"DEFENDER"},{"CV-47"},{"SCHMIDT SCOUT"},{"KRIEG 552"},{"MAGNUM SNIPER RIFLE"},
						{"D3/AU-1"},{"CLARION"},{"BULLPUP"},{"MAVERICK M4A1"},{"KRIEG 550 COMMANDO"},
						{"M249"},{"KEVLAR"},{"KEVLAR + HELMET"},{"FLASHBANG"},{"HE GRENADE"},
						{"SMOKE GRENADE"},{"DEFUSAL KIT"},{"NIGHTVISION"},{"TACTICAL SHIELD"}};

/*Weapon and Equipment: ClientCommands*/
new g_Items[MAX_ITEMS][MAX_NAME_LENGTH]={{"glock"},{"usp"},{"p228"},{"deagle"},{"elites"},{"fn57"},{"m3"},{"xm1014"},
					{"mac10"},{"mp5"},{"ump45"},{"p90"},{"tmp"},{"galil"},{"ak47"},{"scout"},{"sg552"},
					{"awp"},{"g3sg1"},{"famas"},{"aug"},{"m4a1"},{"sg550"},{"m249"},
					{"vest"},{"vesthelm"},{"flash"},{"hegren"},{"sgren"},{"defuser"},{"nvgs"},{"shield"}};

/*New ClientCommands for weapons in CS 1.6 OMG...*/		
new g_ItemsNew[MAX_ITEMS][MAX_NAME_LENGTH]={{"9x19mm"},{"km45"},{"229compact"},{"nighthawk"},{"elites"},{"fiveseven"},{"12gauge"},
					{"autoshotgun"},{"mac10"},{"smg"},{"ump45"},{"c90"},{"mp"},
					{"defender"},{"cv47"},{"scout"},{"krieg552"},
					{"magnum"},{"d3au1"},{"clarion"},{"bullup"},{"m4a1"},{"krieg550"},{"m249"},
					{"vest"},{"vesthelm"},{"flash"},{"hegren"},{"sgren"},{"defuser"},{"nvgs"},{"shield"}};
					
new g_ItemsDisplay[MAX_ITEMS][]={{"............."},{"...................."},{"........"},{"........."},{"................"},{"............."},{"................"},
				{"...."},{".............."},{"....................."},{"............."},{"......................"},{"......................"},
				{".............."},{"..................."},{"................."},{"............"},
				{".............."},{"................"},{"..............."},{"..................."},{"................"},{"............"},{"................."},
				{"....................."},{"......."},{"..................."},{"............."},{"................."},{"..........."},{"...................."},{"................"}};

/*Checking Menu*10+Item if you use buy and menuselect with bindings*/
/*key combination for CT*/
new g_ItemsCT[MAX_ITEMS]=	{11,12,13,14,0,15,21,22,
				0,32,33,34,31,0,0,42,0,
				46,0,41,44,43,45,51,
				81,82,83,84,85,86,87,88};
/*key combination for T*/
new g_ItemsT[MAX_ITEMS]=	{11,12,13,14,15,0,21,22,
				31,32,33,34,0,41,42,43,44,
				45,46,0,0,0,46,51,
				81,82,83,84,85,0,86,0};
/*restricted weapon array for the new buy-system*/					
new g_RestrictedWeapon[MAX_ITEMS];
new g_RestrictedWeaponNew[MAX_ITEMS];
/*restricted key-combination for the old buy-system*/
new g_restrictedItemCT[MAX_ITEMS];
new g_restrictedItemT[MAX_ITEMS];
/*counting restrictions for optimizing the code*/
new g_restricted;

/*The old way with buy and menuselect*/
new g_UserMenuSelect[MAX_PLAYERS];
new g_UserMenu[MAX_PLAYERS];


public plugin_init(){
	plugin_registerinfo("Weapon restriction for CS 1.6","Restrict items in Counterstrike mod",g_Version);
	plugin_registercmd("admin_ct","admin_changeteam",ACCESS_CHANGE_TEAM,"admin_ct <target>: Changes target to the counter-terrorist team.");
	plugin_registercmd("admin_t","admin_changeteam",ACCESS_CHANGE_TEAM,"admin_t <target>: Changes target to the terrorist team.");
	plugin_registercmd("admin_vote_restart","admin_vote_restart",ACCESS_VOTE_RESTART,"admin_vote_restart: Starts a vote to restart the round.");
	plugin_registercmd("admin_restartround","admin_restartround",ACCESS_RESTART,"admin_restartround <seconds>: Restarts the round.");
	plugin_registercmd("admin_enableequipment","enableequip",ACCESS_RESTRICT,"admin_enableequipment: Allows anyone to buy any equipment.");
	plugin_registercmd("admin_enableallweapons","enableallweapons",ACCESS_RESTRICT,"admin_enableallweapons: Allows anyone to buy any weapon.");
	plugin_registercmd("admin_enableitem","enableitem",ACCESS_RESTRICT,"admin_enableitem <item-id>: Allows anyone to buy the specified item.");
	plugin_registercmd("admin_enablemenu","enablemenu",ACCESS_RESTRICT,"admin_enablemenu <menu>: Allows anyone to buy anything on the specified menu.");
	plugin_registercmd("admin_enablepermanent","enableitem",ACCESS_RESTRICT,"admin_enablepermanent <item-id>: Allows anyone to buy the specified item permanently.");
	plugin_registercmd("admin_restrictequipment","restrictequip",ACCESS_RESTRICT,"admin_restrictequipment: Forbids anyone from buying any equipment.");
	plugin_registercmd("admin_restrictallweapons","restrictallweapons",ACCESS_RESTRICT,"admin_restrictallweapons: Forbids anyone from buying any weapon.");
	plugin_registercmd("admin_restrictitem","restrictitem",ACCESS_RESTRICT,"admin_restrictitem <item-id>: Forbids anyone from buying the specified item.");
	plugin_registercmd("admin_restrictmenu","restrictmenu",ACCESS_RESTRICT,"admin_restrictmenu <menu>: Forbids anyone from buying anything on the specified menu.");
	plugin_registercmd("admin_restrictpermanent","restrictitem",ACCESS_RESTRICT,"admin_restrictpermanent <item-id>: Forbids anyone from buying the specified item permanently.");
	plugin_registercmd("admin_showitems","showitems",ACCESS_RESTRICT,"admin_showitems <no.>: Displays the ITEM-IDs for all items");
	plugin_registercmd("admin_weaponscheck","weaponscheck",ACCESS_RESTRICT,"admin_weaponscheck <^"on^" | ^"off^">: Toggles whether or not weapon restrictions are used.");
	plugin_registercmd("buy","set_menu",ACCESS_ALL);
	plugin_registercmd("buyequip","set_menu",ACCESS_ALL);
	plugin_registercmd("menuselect","menuselect",ACCESS_ALL);
	/*register all buy commands of client*/
	new i;
	new Data[MAX_DATA_LENGTH];
	new iRestrict;
	for(i=0;i<=MAX_ITEMS;i++){
		plugin_registercmd(g_Items[i],"buy_item",ACCESS_ALL);
		plugin_registercmd(g_ItemsNew[i],"buy_item",ACCESS_ALL);
		snprintf(Data,MAX_DATA_LENGTH,"CS_RESTRICT_%s",g_ItemsNew[i]);
		if(get_vaultnumdata(Data,iRestrict) && iRestrict==LOCKED){
			restrict_item(i);
			snprintf(Data,MAX_TEXT_LENGTH,"[ADMIN] %s is restricted permanently!",g_ItemsFakeName[i]);
			log(Data);
		}
	}
	
	return PLUGIN_CONTINUE;
}

/* admin_ct <target>
   admin_t <target> */   
public admin_changeteam(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new TargetName[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];	
	convert_string(HLCommand,Command,MAX_NAME_LENGTH);
	convert_string(HLData,Data,MAX_NAME_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	if (check_user(Data) == 1) {
		get_username(Data,TargetName,MAX_NAME_LENGTH);
		say_command(User,Command,TargetName);
		if (check_immunity(TargetName) != 0) {
			snprintf(Text, MAX_TEXT_LENGTH, "Laf. You can't move %s onto another team, you silly bear.", TargetName);
			messageex(User,Text,print_chat);
		} else if (streq(Command,"admin_ct")==1) {
			execclient(TargetName, "chooseteam;menuselect 2;menuselect 3"); 
		} else if (streq(Command,"admin_t")==1) {
			execclient(TargetName, "chooseteam;menuselect 1;menuselect 3"); 
		}
	} else {
		selfmessage("Unrecognized player: ");
		selfmessage(Data);
	}

	return PLUGIN_HANDLED;
}

/* admin_restartround <seconds> */
public admin_restartround(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	execute_command(User,Command,"sv_restartround",Data);
	return PLUGIN_HANDLED;
}

/* Restart vote by Nathan O'Sullivan */
/* admin_vote_restart */
public admin_vote_restart(HLCommand,HLData,HLUserName,UserIndex) {
	new unused[MAX_NAME_LENGTH];
	
	if (vote_allowed()!=1) {
		selfmessage( "Vote not allowed at this time.");
		return PLUGIN_HANDLED;
	}

	vote("Restart map & begin play?","Yes","No","restart_vote",unused);
	return PLUGIN_HANDLED;
}

public restart_vote(a,b,c,d) {
	new Text[MAX_TEXT_LENGTH];
	
	if ( a == 1 ) {
		new ratio = getvar("map_ratio");
		if ( ratio == 0 ) {
			say("Restart vote is not enabled");
			return;
		}
		if ( c > (ratio/100)*d ) {
			new tleft, tlimit;
			tleft = timeleft() - 10; // # seconds till restart!
			tlimit = getvar("mp_timelimit");
			tlimit = tlimit + (tlimit - tleft/60);
			
			snprintf(Text, MAX_TEXT_LENGTH, "mp_timelimit %i", tlimit);
			exec(Text);
			exec ("sv_restartround 10");
		} else {
			say("Not enough votes for map restart");
		}
	} else {
		say("Not enough votes for map restart");
	}
}


/*--------------------------------------------------------*/
/*------------------- WEAPON-RESTRICTION -----------------*/
/*--------------------------------------------------------*/

/*The old way with buy and menuselect*/
public set_menu(HLCommand, HLData, HLUserName, UserIndex){
	new Command[MAX_COMMAND_LENGTH];
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	if(g_restricted>0){
		g_UserMenuSelect[UserIndex]=LOCKED;
		g_UserMenu[UserIndex]=ENABLED;
		if(strcmp(Command,"buyequip")==0){
			g_UserMenu[UserIndex]=MENU_EQUIPMENT;	
		}
	}
	return PLUGIN_CONTINUE;
}

public menuselect(HLCommand, HLData, HLUserName, UserIndex){
	if (getvar("admin_cs_restrict")==1 && g_restricted>0) {
		new User[MAX_NAME_LENGTH];
		new Data[MAX_NUMBER_LENGTH];
		new iTeam;
		new iItem;
		new iMenu;
		new i;
		convert_string(HLUserName,User,MAX_NAME_LENGTH);
		convert_string(HLData,Data,MAX_DATA_LENGTH);
		strstripquotes(Data);
		iMenu=strtonum(Data);
		if(g_UserMenuSelect[UserIndex]==LOCKED){
			if(iMenu==MENU_CANCEL){
				g_UserMenuSelect[UserIndex]=ENABLED;
				return PLUGIN_CONTINUE;
			}else if(g_UserMenu[UserIndex]==ENABLED && iMenu!=MENU_PRIMAMMO && iMenu!=MENU_SECAMMO && iMenu!=MENU_INVALID && iMenu!=MENU_INVALID2){
				g_UserMenu[UserIndex]=iMenu;
				return PLUGIN_CONTINUE;
			}else{
				iItem=g_UserMenu[UserIndex]*10+iMenu;
				get_userTeam(User,iTeam);
				if(iTeam==TERRORIST){
					for(i=0;i<MAX_ITEMS;i++){
						if(iItem==g_restrictedItemT[i]){
							messageex(User,"Item currently not allowed",print_type:print_center);
							execclient(User,"menuselect 10");/*this works...*/
							/*g_UserMenuSelect[UserIndex]=ENABLED; this does not work...*/
							return PLUGIN_HANDLED;
						}
					}
				}else if(iTeam==COUNTER){
					for(i=0;i<MAX_ITEMS;i++){
						if(iItem==g_restrictedItemCT[i]){
							messageex(User,"Item currently not allowed",print_type:print_center);
							execclient(User,"menuselect 10");/*this works...*/
							/*g_UserMenuSelect[UserIndex]=ENABLED; this does not work...*/
							return PLUGIN_HANDLED;
						}
					}
				}
				execclient(User,"menuselect 10"); /*this works...*/
				/*g_UserMenuSelect[UserIndex]=ENABLED; this does not work...*/
				return PLUGIN_CONTINUE;
			}
		}
	}
	return PLUGIN_CONTINUE;
}
		
/*The new system using client commands*/ 	
public buy_item(HLCommand, HLData, HLUserName, UserIndex){
	if (getvar("admin_cs_restrict")==1 && g_restricted > 0) {
		new Command[MAX_COMMAND_LENGTH];
		new User[MAX_NAME_LENGTH];
		new i;
		convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
		convert_string(HLUserName,User,MAX_NAME_LENGTH);
		for(i=0;i<MAX_ITEMS;i++){
			if((strcmp(g_Items[i],Command)==0 && g_RestrictedWeapon[i]==LOCKED) || (strcmp(g_ItemsNew[i],Command)==0 && g_RestrictedWeaponNew[i]==LOCKED)){
				messageex(User,"Item currently not allowed",print_type:print_center);
				return PLUGIN_HANDLED;
			}
		}
	}
	return PLUGIN_CONTINUE;
}

/*SINGLE ITEM RESTRICTION*/
		
public enableitem(HLCommand,HLData,HLUserName,UserIndex){
	if (getvar("admin_cs_restrict")==1){
		if(g_restricted>0){
			new Text[MAX_TEXT_LENGTH];
			new Data[MAX_DATA_LENGTH];
			new Command[MAX_COMMAND_LENGTH];
			new User[MAX_NAME_LENGTH];
			new iItem;
			new i;
			convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
			convert_string(HLData,Data,MAX_DATA_LENGTH);
			convert_string(HLUserName,User,MAX_NAME_LENGTH);
			
			if(!isnumeric(Data)){
				for(i=0;i<MAX_ITEMS;i++){
					if(strcmp(Data,g_Items[i])==0 || strcmp(Data,g_ItemsNew[i])==0){
						iItem=i;
						break;
					}
				}
			}else{
				iItem=strtonum(Data);
			}
			if(g_RestrictedWeapon[iItem]==LOCKED){
				enable_item(iItem);
				if(strcmp(Command,"admin_enablepermanent")==0){
					snprintf(Text,MAX_TEXT_LENGTH,"CS_RESTRICT_%s",g_ItemsNew[iItem]);
					set_vaultnumdata(Text,ENABLED);
					snprintf(Text,MAX_TEXT_LENGTH,"%s is enabled on all maps permanently!",g_ItemsFakeName[iItem]);
				}else{
					snprintf(Text,MAX_TEXT_LENGTH,"%s is enabled on this map only!",g_ItemsFakeName[iItem]);
				}
				selfmessage(Text);
				log_command(User,Command,Data);
			}else{
				snprintf(Text,MAX_TEXT_LENGTH,"%s is not forbidden!",g_ItemsFakeName[iItem]);
				selfmessage(Text);
			}
		}else{
			selfmessage("No items are forbidden at the moment!");
		}
	}else{
		error_restrict_not_enabled();
	}
	return PLUGIN_HANDLED;
}

public restrictitem(HLCommand,HLData,HLUserName,UserIndex){
	if (getvar("admin_cs_restrict")==1){
		new Text[MAX_TEXT_LENGTH];
		new Data[MAX_DATA_LENGTH];
		new Command[MAX_COMMAND_LENGTH];
		new User[MAX_NAME_LENGTH];
		new iItem;
		new i;
		convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
		convert_string(HLData,Data,MAX_DATA_LENGTH);
		convert_string(HLUserName,User,MAX_NAME_LENGTH);
		
		if(!isnumeric(Data)){
			for(i=0;i<MAX_ITEMS;i++){
				if(strcmp(Data,g_Items[i])==0 || strcmp(Data,g_ItemsNew[i])==0){
					iItem=i;
					break;
				}
			}
		}else{
			iItem=strtonum(Data);
		}
		if(g_RestrictedWeapon[iItem]==ENABLED){
			restrict_item(iItem);
			if(strcmp(Command,"admin_restrictpermanent")==0){
				snprintf(Text,MAX_TEXT_LENGTH,"CS_RESTRICT_%s",g_ItemsNew[iItem]);
				set_vaultnumdata(Text,LOCKED);
				snprintf(Text,MAX_TEXT_LENGTH,"%s is forbidden on all maps permanently!",g_ItemsFakeName[iItem]);
			}else{
				snprintf(Text,MAX_TEXT_LENGTH,"%s is forbidden only on this map!",g_ItemsFakeName[iItem]);
			}
			selfmessage(Text);
			log_command(User,Command,Data);
		}else{
			snprintf(Text,MAX_TEXT_LENGTH,"%s is already forbidden!",g_ItemsFakeName[iItem]);
			selfmessage(Text);
		}
	}else{
		error_restrict_not_enabled();
	}
	return PLUGIN_HANDLED;
}

stock isnumeric(Str[]){  
	new length = strlen(Str);  
	if (length > 0 ) {  
		if (Str[0] >= '0' && Str[0] <= '9' || Str[0] == '-') {  
			for ( new i = 1; i < length ; i++ ) {
				if (Str[i] < '0' || Str[i] > '9') {
					return 0; 
				}
			}
		} else { 
			return 0; 
		} 
	} else  {
		return 0;
	}
	return 1;  
}

/*SINGLE MENU RESTRICTION*/
public enablemenu(HLCommand,HLData,HLUserName,UserIndex){
	if (getvar("admin_cs_restrict")==1){
		new Text[MAX_TEXT_LENGTH];
		new Data[MAX_DATA_LENGTH];
		new Command[MAX_COMMAND_LENGTH];
		new User[MAX_NAME_LENGTH];
		new iMenu;
		new restrictstart;
		new restrictend;
		new i;
		convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
		convert_string(HLData,Data,MAX_DATA_LENGTH);
		convert_string(HLUserName,User,MAX_NAME_LENGTH);
		iMenu=strtonum(Data);
		if(MENU_INVALID < iMenu < MENU_SECAMMO || iMenu==MENU_EQUIPMENT){
			switch (iMenu){
				case 1:{
					restrictstart=0;
					restrictend=PISTOLS;
				}
				case 2:{
					restrictstart=PISTOLS+1;
					restrictend=SHOTGUNS;
				}
				case 3:{
					restrictstart=SHOTGUNS+1;
					restrictend=SMG;
				}
				case 4:{
					restrictstart=SMG+1;
					restrictend=RIFLES;
				}
				case 5:{
					restrictstart=RIFLES+1;
					restrictend=MG;
				}
				case 8:{
					restrictstart=MG+1;
					restrictend=EQUIPMENT;
				}
			}
			for(i=restrictstart;i<=restrictend;i++){
				if(g_RestrictedWeapon[i]==LOCKED){
					enable_item(i);
				}
			}
			snprintf(Text,MAX_TEXT_LENGTH,"All items in menu %i are enabled!",iMenu);
			selfmessage(Text);
			log_command(User,Command,Data);
		}else{
			selfmessage("Invalid Menu Number!");
		}
	}else{
		error_restrict_not_enabled();
	}
	return PLUGIN_HANDLED;
}

public restrictmenu(HLCommand,HLData,HLUserName,UserIndex){
	if (getvar("admin_cs_restrict")==1){
		new Text[MAX_TEXT_LENGTH];
		new Data[MAX_DATA_LENGTH];
		new Command[MAX_COMMAND_LENGTH];
		new User[MAX_NAME_LENGTH];
		new iMenu;
		new restrictstart;
		new restrictend;
		new i;
		convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
		convert_string(HLData,Data,MAX_DATA_LENGTH);
		convert_string(HLUserName,User,MAX_NAME_LENGTH);
		iMenu=strtonum(Data);
		if(MENU_INVALID < iMenu < MENU_SECAMMO || iMenu==MENU_EQUIPMENT){
			switch (iMenu){
				case 1:{
					restrictstart=0;
					restrictend=PISTOLS;
				}
				case 2:{
					restrictstart=PISTOLS+1;
					restrictend=SHOTGUNS;
				}
				case 3:{
					restrictstart=SHOTGUNS+1;
					restrictend=SMG;
				}
				case 4:{
					restrictstart=SMG+1;
					restrictend=RIFLES;
				}
				case 5:{
					restrictstart=RIFLES+1;
					restrictend=MG;
				}
				case 8:{
					restrictstart=MG+1;
					restrictend=EQUIPMENT;
				}	
			}
			for(i=restrictstart;i<=restrictend;i++){
				if(g_RestrictedWeapon[i]==ENABLED){
					restrict_item(i);
				}
			}
			snprintf(Text,MAX_TEXT_LENGTH,"All items in menu %i are restricted!",iMenu);
			selfmessage(Text);
			log_command(User,Command,Data);
		}else{
			selfmessage("Invalid Menu Number!");
		}
	}else{
		error_restrict_not_enabled();
	}
	return PLUGIN_HANDLED;
}

/*ALL EQUIPMENT RESTRICTION*/
public enableequip(HLCommand,HLData,HLUserName,UserIndex){
	if (getvar("admin_cs_restrict")==1){
		new Text[MAX_TEXT_LENGTH];
		new User[MAX_NAME_LENGTH];
		new i;
		convert_string(HLUserName,User,MAX_NAME_LENGTH);
		for(i=MG+1;i<=EQUIPMENT;i++){
			if(g_RestrictedWeapon[i]==LOCKED){
				enable_item(i);
			}
		}
		snprintf(Text,MAX_TEXT_LENGTH,"All items are enabled in menu equipment!");
		selfmessage(Text);
		log_command(User,"admin_enableequip",Text);
	}else{
		error_restrict_not_enabled();
	}
	return PLUGIN_HANDLED;
}

public restrictequip(HLCommand,HLData,HLUserName,UserIndex){
	if (getvar("admin_cs_restrict")==1){
		new Text[MAX_TEXT_LENGTH];
		new User[MAX_NAME_LENGTH];
		new i;
		convert_string(HLUserName,User,MAX_NAME_LENGTH);
		for(i=MG+1;i<=EQUIPMENT;i++){
			if(g_RestrictedWeapon[i]==ENABLED){
				restrict_item(i);
			}
		}
		snprintf(Text,MAX_TEXT_LENGTH,"All items are restricted in menu equipment!");
		selfmessage(Text);
		log_command(User,"admin_restrictequip",Text);
	}else{
		error_restrict_not_enabled();
	}
	return PLUGIN_HANDLED;
}

/*ALL WEAPONS RESTRICTION*/
public enableallweapons(HLCommand,HLData,HLUserName,UserIndex){
	if (getvar("admin_cs_restrict")==1){
		new Text[MAX_TEXT_LENGTH];
		new User[MAX_NAME_LENGTH];
		new i;
		convert_string(HLUserName,User,MAX_NAME_LENGTH);
		for(i=0;i<=MG;i++){
			if(g_RestrictedWeapon[i]==LOCKED){
				enable_item(i);
			}
		}
		snprintf(Text,MAX_TEXT_LENGTH,"All weapons are enabled!");
		selfmessage(Text);
		log_command(User,"admin_enableallweapons",Text);
	}else{
		error_restrict_not_enabled();
	}
	return PLUGIN_HANDLED;
}

public restrictallweapons(HLCommand,HLData,HLUserName,UserIndex){
	if (getvar("admin_cs_restrict")==1){
		new Text[MAX_TEXT_LENGTH];
		new User[MAX_NAME_LENGTH];
		new i;
		convert_string(HLUserName,User,MAX_NAME_LENGTH);
		for(i=0;i<=MG;i++){
			if(g_RestrictedWeapon[i]==ENABLED){
				restrict_item(i);
			}
		}
		snprintf(Text,MAX_TEXT_LENGTH,"All weapons are restricted!");
		selfmessage(Text);
		log_command(User,"admin_restrictallweapons",Text);
	}else{
		error_restrict_not_enabled();
	}
	return PLUGIN_HANDLED;
}


/*FILL THE ARRAYS WITH DATA*/
enable_item(Item_ID){
	g_RestrictedWeaponNew[Item_ID]=ENABLED;
	g_RestrictedWeapon[Item_ID]=ENABLED;
	g_restrictedItemCT[Item_ID]=ENABLED;
	g_restrictedItemT[Item_ID]=ENABLED;
	g_restricted--;
}

restrict_item(Item_ID){
	g_RestrictedWeaponNew[Item_ID]=LOCKED;
	g_RestrictedWeapon[Item_ID]=LOCKED;
	g_restrictedItemCT[Item_ID]=g_ItemsCT[Item_ID];
	g_restrictedItemT[Item_ID]=g_ItemsT[Item_ID];
	g_restricted++;
}

/*ERROR MESSAGE, IF 'admin_cs_restrict' is not set to 1*/	
error_restrict_not_enabled(){
	selfmessage("* ITEM-RESTRICTION *");
	selfmessage("* Restriction is useless, because 'admin_cs_restrict' not enabled.");
	selfmessage("* Use command 'admin_weaponcheck ^"on^" first, to enable item-restriction.");
	selfmessage("* Check your settings regarding 'admin_cs_restrict' in adminmod.cfg!");
}
	
public showitems(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new YesNo[4];
	new i;
	new iNr;
	new maxnr;
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	if(strncasecmp(Data,"all",3)==0){
                iNr=0;
                maxnr=MAX_ITEMS;
        }else{
		iNr=strtonum(Data);
		if(iNr<0 || iNr>MAX_ITEMS){
			iNr=0;
		}
		maxnr=iNr+10;
		if(maxnr>MAX_ITEMS){
			maxnr=MAX_ITEMS;
		}
	}
	selfmessage("- WEAPON-RESTRICTION - ");
	selfmessage("ITEM-ID -- Restricted -- Item-Shortname ------ ITEM-NAME");
	for(i=iNr;i<maxnr;i++){
		if(g_RestrictedWeapon[i]==LOCKED){
			strcpy(YesNo,"Yes",4);
		}else{
			strcpy(YesNo,"No",4);
		}
		snprintf(Text,MAX_TEXT_LENGTH,"%3i.............%5s............%s/%s%s%s",i,YesNo,g_Items[i],g_ItemsNew[i],g_ItemsDisplay[i],g_ItemsFakeName[i]);
		selfmessage(Text);
	}
	snprintf(Text,MAX_TEXT_LENGTH,"-- item-ids %i - %i of %i items --",iNr,i-1,MAX_ITEMS);
	selfmessage(Text);
	if(i<MAX_ITEMS){
		snprintf(Text,MAX_TEXT_LENGTH,"-- Use 'admin_showitems %i' for more --",i);
		selfmessage(Text);
	}
	return PLUGIN_HANDLED;
}


/* weaponscheck <"on" | "off"> */
public weaponscheck(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];

	convert_string(HLCommand,Command,MAX_NAME_LENGTH);
	convert_string(HLData,Data,MAX_NAME_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	if(check_param(Data)==1) {
		execute_command(User,Command,"admin_cs_restrict","1");
	} else {
		execute_command(User,Command,"admin_cs_restrict","0");
	}
	return PLUGIN_HANDLED;
}

public plugin_connect(HLUserName, HLIP, UserIndex) {
	if (UserIndex >= 1 && UserIndex <= MAX_PLAYERS) {
		g_UserMenuSelect[UserIndex]=ENABLED;
		g_UserMenu[UserIndex]=ENABLED;
	}
	return PLUGIN_CONTINUE;
}

public plugin_disconnect(HLUserName, UserIndex) {
	if (UserIndex >= 1 && UserIndex <= MAX_PLAYERS) {
		g_UserMenuSelect[UserIndex]=ENABLED;
		g_UserMenu[UserIndex]=ENABLED;
	}
	return PLUGIN_CONTINUE;
}


